# interface.tcl
# user interface module for blobby modeler 1.0
# steven t. huang
# started: 04/05/95
# ended:

# set up main window and drawing areas

set bm_version 1.0
set tcl_version [info tclversion]

puts "Loading Blobby Modeler V$bm_version..."

frame .mbar -relief raised -bd 2         ;# menu bar
frame .fdrawarea                         ;# drawing area
frame .flpane                            ;# lefthand pane
frame .frpane                            ;# righthand pane
canvas .fadarea -width 320 -height 200 -relief raised ;# xy window
frame .faicons                           ;# xy window's icons
canvas .fbdarea -width 320 -height 200 -relief raised ;# xz window
frame .fbicons                           ;# xz window's icons
canvas .fcdarea -width 320 -height 200 -relief raised ;# yz window
frame .fcicons                           ;# yz window's icons
canvas .fddarea -width 320 -height 200 -relief raised ;# free window
frame .fdicons                           ;# free window's icons

# labels for the editing windows

.fadarea create text 160 0 -text "y" -anchor ne \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.fadarea create text 319 100 -text "x" -anchor se \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.fbdarea create text 160 0 -text "y" -anchor ne \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.fbdarea create text 319 100 -text "z" -anchor se \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.fcdarea create text 160 200 -text "z" -anchor se \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.fcdarea create text 319 100 -text "x" -anchor se \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*    

pack .mbar .fdrawarea -side top -fill x
pack .flpane .frpane -in .fdrawarea -side left
pack .fadarea .faicons .fcdarea .fcicons -in .flpane -side top
pack .fbdarea .fbicons .fddarea .fdicons -in .frpane -side top

# set up all the buttons

button .ba1 -bitmap @$cmd_dir/../bitmaps/pencil.ico -command draw
button .ba2 -bitmap @$cmd_dir/../bitmaps/arrow.ico -command get
button .ba3 -bitmap @$cmd_dir/../bitmaps/larrow.ico -command alf
button .ba4 -bitmap @$cmd_dir/../bitmaps/rarrow.ico -command art
button .ba5 -bitmap @$cmd_dir/../bitmaps/uarrow.ico -command aup
button .ba6 -bitmap @$cmd_dir/../bitmaps/darrow.ico -command adn
button .ba7 -bitmap @$cmd_dir/../bitmaps/zoomout.ico -command azout
button .ba8 -bitmap @$cmd_dir/../bitmaps/zoomin.ico -command azin
pack .ba1 .ba2 .ba3 .ba4 .ba5 .ba6 .ba7 .ba8 -in .faicons -side left

button .bb1 -bitmap @$cmd_dir/../bitmaps/pencil.ico -command draw
button .bb2 -bitmap @$cmd_dir/../bitmaps/arrow.ico -command get
button .bb3 -bitmap @$cmd_dir/../bitmaps/larrow.ico -command blf
button .bb4 -bitmap @$cmd_dir/../bitmaps/rarrow.ico -command brt
button .bb5 -bitmap @$cmd_dir/../bitmaps/uarrow.ico -command bup
button .bb6 -bitmap @$cmd_dir/../bitmaps/darrow.ico -command bdn
button .bb7 -bitmap @$cmd_dir/../bitmaps/zoomout.ico -command bzout
button .bb8 -bitmap @$cmd_dir/../bitmaps/zoomin.ico -command bzin
pack .bb1 .bb2 .bb3 .bb4 .bb5 .bb6 .bb7 .bb8 -in .fbicons -side left

button .bc1 -bitmap @$cmd_dir/../bitmaps/pencil.ico -command draw
button .bc2 -bitmap @$cmd_dir/../bitmaps/arrow.ico -command get
button .bc3 -bitmap @$cmd_dir/../bitmaps/larrow.ico -command clf
button .bc4 -bitmap @$cmd_dir/../bitmaps/rarrow.ico -command crt
button .bc5 -bitmap @$cmd_dir/../bitmaps/uarrow.ico -command cup
button .bc6 -bitmap @$cmd_dir/../bitmaps/darrow.ico -command cdn
button .bc7 -bitmap @$cmd_dir/../bitmaps/zoomout.ico -command czout
button .bc8 -bitmap @$cmd_dir/../bitmaps/zoomin.ico -command czin
pack .bc1 .bc2 .bc3 .bc4 .bc5 .bc6 .bc7 .bc8 -in .fcicons -side left

button .bd1 -bitmap @$cmd_dir/../bitmaps/uturn.ico -command BMu
button .bd2 -bitmap @$cmd_dir/../bitmaps/dturn.ico -command BMd
button .bd3 -bitmap @$cmd_dir/../bitmaps/rturn.ico -command BMr
button .bd4 -bitmap @$cmd_dir/../bitmaps/lturn.ico -command BMl
button .bd5 -bitmap @$cmd_dir/../bitmaps/cwturn.ico -command BMcw
button .bd6 -bitmap @$cmd_dir/../bitmaps/ccwturn.ico -command BMccw
button .bd7 -bitmap @$cmd_dir/../bitmaps/zoomout.ico -command BMzo
button .bd8 -bitmap @$cmd_dir/../bitmaps/zoomin.ico -command BMzi
pack .bd1 .bd2 .bd3 .bd4 .bd5 .bd6 .bd7 .bd8 -in .fdicons -side left

# define the menu

menubutton .mbar.file -text "File" -underline 0 \
    -menu .mbar.file.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
menubutton .mbar.edit -text "Edit" -underline 0 \
    -menu .mbar.edit.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
menubutton .mbar.options -text "Options" -underline 0 \
    -menu .mbar.options.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
menubutton .mbar.help -text "Help" -underline 0 \
    -menu .mbar.help.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
pack .mbar.file .mbar.edit .mbar.options -side left
pack .mbar.help -side right

menu .mbar.file.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.mbar.file.menu add command -label "New " -accelerator "Ctrl-n" \
    -underline 0 -command new
.mbar.file.menu add command -label "Open.. " -accelerator "Ctrl-o" \
    -underline 0 -command openfile
.mbar.file.menu add command -label "Save " -accelerator "Ctrl-s" \
    -underline 0 -command savefile
.mbar.file.menu add command -label "Save As.. " \
    -underline 1 -command saveasfile
.mbar.file.menu add command -label "Export.. " -accelerator "Ctrl-e" \
    -underline 0 -command export
.mbar.file.menu add separator
.mbar.file.menu add command -label "Quit " -accelerator "Ctrl-q" \
    -underline 0 -command quit

menu .mbar.edit.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.mbar.edit.menu add command -label "Cut " -accelerator "Ctrl-x" \
    -underline 0 -command cut
.mbar.edit.menu add command -label "Copy " -accelerator "Ctrl-c" \
    -underline 1 -command copy
.mbar.edit.menu add command -label "Paste " -accelerator "Ctrl-v" \
    -underline 1 -command paste
.mbar.edit.menu add command -label "Select All " -accelerator "Ctrl-a" \
    -underline 0 -command selectall
.mbar.edit.menu add separator
.mbar.edit.menu add command -label "Strength " -accelerator "Ctrl-t" \
    -underline 1 -command chgstrength

menu .mbar.options.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.mbar.options.menu add checkbutton -label "Free window " \
    -variable freewindow -command freeops
.mbar.options.menu add checkbutton -label "Grid " -variable grid \
    -command freeops
.mbar.options.menu add command -label "Grid Step " \
    -underline 0 -command chggridsize

menu .mbar.help.menu \
    -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
.mbar.help.menu add command -label "Index.. " -underline 0 \
    -command help
.mbar.help.menu add command -label "About.. " -underline 0 \
    -command vanity

tk_menuBar .mbar .mbar.file .mbar.edit .mbar.options .mbar.help
focus .mbar

# subroutines

proc filedialog {w action} {

# implements the dialog box used by routines needing a filename selected
# from a list or entered
# entry: w               widget name
#        action          verb to display in window
# exit:  returns 0 if ok, 1 if cancel
#        modifies global variables filename and button2

    global filename button2 cmd_dir

    toplevel $w -class Dialog
    wm title $w "File $action..."
    wm iconname $w Dialog
    label $w.l1 -text "Selection" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry $w.e1 -width 20 -relief sunken -bd 2 -textvariable filename \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label  $w.l2 -text "Files" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    frame $w.c1
    listbox $w.lb1 -relief sunken -bd 2 -yscrollcommand "$w.s1 set" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    scrollbar $w.s1 -command "$w.lb1 yview"
    set filelist [glob -nocomplain {*.bm}]
    if {[llength $filelist] > 0} {       ;# check if empty list first
        foreach i [lsort [glob {*.bm}]] {
            $w.lb1 insert end $i
        }
    }
    frame $w.c2
    button $w.b1 -text "Ok" -command {set button2 0} \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    button $w.b2 -text "Cancel" -command {set button2 1} \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    pack $w.l1 $w.e1 $w.l2 -side top -pady 1m -padx 2m -anchor w
    pack $w.c1 -side top -padx 2m
    pack $w.c2 -side top -padx 2m
    pack $w.lb1 $w.s1 -in $w.c1 -side left -fill y
    pack $w.b1 $w.b2 -in $w.c2 -side left -expand 1 \
       -padx 3m -pady 3m -ipadx 2m -ipady 1m

    bind $w.e1 <Return> { set button2 0 }
    bind $w <Return> { set button2 0 }
    tk_listboxSingleSelect $w.lb1
    if {[llength $filelist] > 0} {        ;# bind only if non-empty
        bind $w.lb1 <Double-1> {
            set filename [selection get]
        }
    }

    set oldfocus [focus]
    grab set $w
    focus $w
            
    tkwait variable button2
    destroy $w
    focus $oldfocus
    return $button2
}

proc dialog {w title text bitmap default args} {

# implements a general pop-up dialog displaying an icon, message, and
# any number of buttons
# entry: w               widget
#        title
#        text
#        bitmap
#        default         which button is default ([CR] invoked)
#        args            button names
# exit:  returns button selected
#        modifies global variable button

    global button

    # create toplevel window and divide into top and bottom parts
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both

    # fill top part with bitmap and message
    message $w.top.msg -width 3i -text $text \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    pack $w.top.msg -side right -expand 1 -fill both -padx 3m -pady 3m
    if {$bitmap != ""} {
        label $w.top.bitmap -bitmap $bitmap
        pack $w.top.bitmap -side left -padx 3m -pady 3m
    }

    # create a row of buttons
    set i 0
    foreach but $args {
        button $w.bot.button$i -text $but -command "set button $i" \
            -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
        if {$i == $default} {
            frame $w.bot.default -relief sunken -bd 1
            raise $w.bot.button$i
            pack $w.bot.default -side left -expand 1 -padx 3m -pady 2m
            pack $w.bot.button$i -in $w.bot.default -side left \
                -padx 2m -pady 2m -ipadx 2m -ipady 2m
        } else {
            pack $w.bot.button$i -side left -expand 1 -padx 3m -pady 3m \
                -ipadx 2m -ipady 1m
        }
        incr i
    }

    # set up bindings
    if {$default >= 0} {
        bind $w <Return> "$w.bot.button$default flash; \
            set button $default"
    }
    set oldfocus [focus]
    grab set $w
    focus $w

    # wait for response
    tkwait variable button
    destroy $w
    focus $oldfocus
    return $button
}

proc getstrength {w mode} {

# implements a dialog box which prompts for the strength of the atom
# entry: w               widget
#        mode            "New" node or "Edit" node
# exit:  returns strength
#        modifies global variable strength

    global strength

    toplevel $w -class Dialog
    wm title $w "$mode Node"
    wm iconname $w "$mode Node"

    label $w.l -text "Strength: " \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry $w.e -width 10 -relief sunken -bd 2 -textvariable strength \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*    
    pack $w.l $w.e -side left -padx 1m -pady 2m
    bind $w.e <Return> {
        if {[regexp {^-?[0-9]?\.[0-9]*$} $strength] == 1} {
            set done 1
        }
    }
    bind $w <Return> {
        if {[regexp {^\-?[0-9]?[.][0-9]*$} $strength] == 1} {
            set done 1
        }
    }

    # wait until [CR] pressed
    set oldfocus [focus]
    tkwait visibility $w
    grab set $w
    focus $w
    tkwait variable done
    destroy $w
    focus $oldfocus
    return $strength
}     

proc forallmatches {w pattern script} {

# finds ranges of characters that match a given expression
# entry: w               widget
#        pattern         regular expression
#        script          what to do if found

    scan [$w index end] %d numlines
    for {set i 1} {$i < $numlines} {incr i} {
        $w mark set last $i.0
        while {[regexp -indices $pattern [$w get last "last lineend"] \
            indices]} {
            $w mark set first "last + [lindex $indices 0] chars"
            $w mark set last "last + 1 chars + [lindex $indices 1] chars"
            uplevel $script
        }
    }
}

proc textwin {w filename title} {

# implements a pop-up text window
# entry: w               widget
#        filename
#        title
# exit:  none

    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w $title
    
    frame $w.frame
    text $w.text -relief raised -bd 2 -yscrollcommand "$w.scroll set"
    scrollbar $w.scroll -command "$w.text yview"
    button $w.button -text "Dismiss the Help window" -command {set done 1} \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    $w.text delete 1.0 end               ;# clear text buffer
    set f [open $filename]
    bind $w.text <Any-KeyPress> {}
    while {![eof $f]} {
        $w.text insert end [read $f 1000]
    }
    close $f
    
    # parse tiny-html tags
    $w.text configure -font -adobe-times-medium-r-*-*-14-*-*-*-*-*-*-*
    forallmatches $w.text "<h1>.*</h1>" { ;# parse for <h1> </h1> pairs
        $w.text tag add h1 "first+4 chars" "last-5 chars"
        $w.text delete first "first+4 chars"
        $w.text delete "last-5 chars" last
    }
    forallmatches $w.text "<h2>.*</h2>" { ;# parse for <h2> </h2> pairs
        $w.text tag add h2 "first+4 chars" "last-5 chars"
        $w.text delete first "first+4 chars"
        $w.text delete "last-5 chars" last
    }
    forallmatches $w.text "<h3>.*</h3>" { ;# parse for <h3> </h3> pairs
        $w.text tag add h3 "first+4 chars" "last-5 chars"
        $w.text delete first "first+4 chars"
        $w.text delete "last-5 chars" last
    }
    forallmatches $w.text "<em>.*</em>" { ;# parse for <em> </em> pairs
        $w.text tag add em "first+4 chars" "last-5 chars"
        $w.text delete first "first+4 chars"
        $w.text delete "last-5 chars" last
    }
    forallmatches $w.text "<b>.*</b>" {  ;# parse for <b> </b> pairs
        $w.text tag add b "first+3 chars" "last-4 chars"
        $w.text delete first "first+3 chars"
        $w.text delete "last-4 chars" last
    }
    $w.text tag configure h1 \
        -font -adobe-times-bold-r-*-*-24-*-*-*-*-*-*-*
    $w.text tag configure h2 \
        -font -adobe-times-bold-r-*-*-20-*-*-*-*-*-*-*
    $w.text tag configure h3 \
        -font -adobe-times-bold-r-*-*-17-*-*-*-*-*-*-*
    $w.text tag configure em \
        -font -adobe-times-medium-i-*-*-14-*-*-*-*-*-*-*
    $w.text tag configure b \
        -font -adobe-times-bold-r-*-*-14-*-*-*-*-*-*-*
    $w.text config -state disabled
    pack $w.scroll -in $w.frame -side right -fill y
    pack $w.text -in $w.frame -side left
    pack $w.frame -side top
    pack $w.button -side top -fill x
    
    set oldfocus [focus]
    tkwait visibility $w
    grab set $w
    focus $w
    tkwait variable done
    destroy $w
    focus $oldfocus
}

proc getgridsize {w} {

# implements a dialog box which prompts for the strength of the atom
# entry: w               widget
#        mode            "New" node or "Edit" node
# exit:  returns strength
#        modifies global variable strength

    global gridsize

    toplevel $w -class Dialog
    wm title $w "Grid size"
    wm iconname $w "Grid size"

    label $w.l -text "Grid size: " \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry $w.e -width 10 -relief sunken -bd 2 -textvariable gridsize \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*    
    pack $w.l $w.e -side left -padx 1m -pady 2m
    bind $w.e <Return> {
        if {[regexp {^[0-9]?\.[0-9]*$} $gridsize] == 1} {
            set done 1
        }
    }
    bind $w <Return> {
        if {[regexp {$[0-9]?\.[0-9]*$} $gridsize] == 1} {
            set done 1
        }
    }

    # wait until [CR] pressed
    set oldfocus [focus]
    tkwait visibility $w
    grab set $w
    focus $w
    tkwait variable done
    destroy $w
    focus $oldfocus
    return $gridsize
}     

# menu item callback functions

proc new {} {

# clears everything after seeking confirmation

    global button nodex nodey nodez nodes noden clipnodex clipnodey
    global clipnodez clipnodes currnode
    
    dialog .newd {New File} {Are you sure you want to discard all changes\
        made so far?} questhead 1 {Make it so} {No}
    if {$button == 0} {
	set nodex {}                     ;# initialize node parallel arrays
	set nodey {}
	set nodez {}
	set nodes {}
	set noden {}
	set clipnodex {}                 ;# clean clipboard
	set clipnodey {}
	set clipnodez {}
	set clipnodes {}
	set currnode -1                  ;# no current node
	BMclear
	refresh
    }
}

proc quit {} {

# makes sure before exiting the program

    global button

    dialog .quitd {Quit Blobby Modeler?} {Are you sure you want to leave\
        this program?} questhead 0 {Make it so} {No}
    if {$button == 0} exit
}

proc openfile {} {

# open a file for reading

    global filename button nodex nodey nodez nodes noden
    global clipnodex clipnodey clipnodez clipnodes currnode

    dialog .ofd {Open File} {Are you sure you want to discard all changes\
        made so far?} questhead 1 {Make it so} {No}
    if {$button == 0 && [filedialog .ofpickd {open}] == 0} {
        if {[file exists $filename] == 1 && [file readable $filename] == 1} {
	    set nodex {}                 ;# initialize node parallel arrays
	    set nodey {}
	    set nodez {}
	    set nodes {}
	    set noden {}
	    set clipnodex {}             ;# clean clipboard
	    set clipnodey {}
	    set clipnodez {}
	    set clipnodes {}
	    set currnode -1              ;# no current node
	    BMclear
	    refresh                      ;# clear the screen first
	    set f [open $filename r]
	    set maxnodes -1              ;# initialize check counters
	    set nodesread 0
	    while {[gets $f line] >= 0} {
		regsub {#.*} $line "" line ;# remove comments
		regexp {[Nn][Oo][Dd][Ee][Ss] ([0-9]+)} $line foo maxnodes
		if {[scan $line "%f %f %f %f" x y z s] == 4} {
	            lappend nodex $x
	            lappend nodey $y
	            lappend nodez $z
	            lappend nodes $s
	            set new [drawnewnode $x $y $z $s]
	            lappend noden $new
	            BMadd $x $y $z $s $new
	            incr nodesread
		}
	    }
	    if {$maxnodes == -1 || $nodesread < $maxnodes} {
		dialog .oferrd {Error!} "Sorry, the file `$filename' does not \
	            have the correct format." error 0 {Ok}
		set nodex {}             ;# initialize node parallel arrays
		set nodey {}
		set nodez {}
		set nodes {}
		set noden {}
		set clipnodex {}         ;# clean clipboard
		set clipnodey {}
		set clipnodez {}
		set clipnodes {}
		set currnode -1          ;# no current node
		BMclear
		refresh                  ;# clear the screen first
	    }
	} else {
	    dialog .oferrd {Error!} "Sorry, you either are not permitted \
	        to open the file `$filename' or it does not exist." error 0 \
	        {Ok}
	}
    }
}

proc writefile {} {

# this procedure is called by savefile and saveasfile to actually
# output the file

    global bm_version tcl_version tk_version
    global nodex nodey nodez nodes filename

    if {[file exists $filename] == 0 || [file writable $filename] == 1} {
        set f [open $filename w]
        puts $f "# Blobby Modeler V$bm_version Tcl$tcl_version/Tk$tk_version"
        puts $f ""
        puts $f [format "nodes %d" [llength $nodex]]
        for {set i 0} {$i < [llength $nodex]} {incr i} {
            puts $f [format "%.4f %.4f %.4f %4f" [lindex $nodex $i] \
                [lindex $nodey $i] [lindex $nodez $i] [lindex $nodes $i]]
        }
        puts $f "#eof"
        close $f
    } else {
        dialog .wfd {Error!} {Sorry, you do not have permission to write\
            to this file} error 0 {Ok}
    }
}

proc savefile {} {

# save a file to disk if one is named

    global filename

    if {[string compare $filename "untitled.bm"] == 0} {
        saveasfile
    } else {
        writefile
    }
}

proc saveasfile {} {

# saves a file to disk, always ask for name

    global filename

    if {[filedialog .openfiled {save}] == 0} {
        wm title . "Blobby Modeler - $filename"
        writefile
    }
}

proc exportd {} {

# dialog for exporting

    global fname size xox xoy xoz xdx xdy xdz button3 filename

    toplevel .xd
    wm title .xd "Export file"
    wm iconname .xd "Export file"
    
    set fname [format "%s.dx" [file rootname $filename]]
    frame .xd.f1
    frame .xd.f2
    frame .xd.f3
    frame .xd.f5
    frame .xd.f2.f1
    frame .xd.f2.f2
    frame .xd.f3.f1
    frame .xd.f3.f2
    frame .xd.f3.f3
    frame .xd.f3.f4
    label .xd.f1.l -text "File name:" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f1.e -width 20 -relief sunken -bd 2 -textvariable fname \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    foreach sz {21 31 41} {
        radiobutton .xd.f2.f1.b$sz -text "$sz x $sz x $sz" -relief flat \
            -variable size -value $sz \
            -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    }
    foreach sz {51 61 71} {
        radiobutton .xd.f2.f2.b$sz -text "$sz x $sz x $sz" -relief flat \
            -variable size -value $sz \
            -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    }
    set size 31
    label .xd.f3.f1.l0 -text "" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label .xd.f3.f1.l1 -text "Origin:" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f2.b1 -width 5 -relief sunken -bd 2 -textvariable xox \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f3.b1 -width 5 -relief sunken -bd 2 -textvariable xoy \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f4.b1 -width 5 -relief sunken -bd 2 -textvariable xoz \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label .xd.f3.f1.l2 -text "Delta:" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f2.b2 -width 5 -relief sunken -bd 2 -textvariable xdx \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f3.b2 -width 5 -relief sunken -bd 2 -textvariable xdy \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    entry .xd.f3.f4.b2 -width 5 -relief sunken -bd 2 -textvariable xdz \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label .xd.f3.f2.l1 -text "X" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label .xd.f3.f3.l1 -text "Y" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    label .xd.f3.f4.l1 -text "Z" \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    button .xd.f5.b0 -text "Proceed" -command {set button3 0} \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    button .xd.f5.b1 -text "Cancel" -command {set button3 1} \
        -font -adobe-helvetica-bold-r-*-*-12-*-*-*-*-*-*-*
    pack .xd.f1 .xd.f2 .xd.f3 .xd.f5 -side top -padx 2m -pady 2m
    pack .xd.f1.l .xd.f1.e -side left
    pack .xd.f2.f1 .xd.f2.f2 -side left
    pack .xd.f2.f1.b21 .xd.f2.f1.b31 .xd.f2.f1.b41 -side top
    pack .xd.f2.f2.b51 .xd.f2.f2.b61 .xd.f2.f2.b71 -side top
    pack .xd.f3.f1 .xd.f3.f2 .xd.f3.f3 .xd.f3.f4 -side left
    pack .xd.f3.f1.l0 .xd.f3.f1.l1 .xd.f3.f1.l2 -side top -padx 1m -pady 1m
    pack .xd.f3.f2.l1 .xd.f3.f2.b1 .xd.f3.f2.b2 -side top -padx 1m -pady 1m
    pack .xd.f3.f3.l1 .xd.f3.f3.b1 .xd.f3.f3.b2 -side top -padx 1m -pady 1m
    pack .xd.f3.f4.l1 .xd.f3.f4.b1 .xd.f3.f4.b2 -side top -padx 1m -pady 1m
    pack .xd.f5.b0 .xd.f5.b1 -side left -padx 2m -ipadx 1m -ipady 1m \
        -expand 1
    foreach i {2 3 4} {
        bind .xd.f3.f$i.b1 <Return> {set dummy [.xd.f3.f2.b1 get]}
        bind .xd.f3.f$i.b2 <Return> {set dummy [.xd.f3.f2.b2 get]}
    }
    bind .xd.f1.e <Return> {set dummy [.xd.f1.e get]}
    set oldfocus [focus]
    tkwait visibility .xd
    grab set .xd
    focus .xd
    tkwait variable button3
    destroy .xd
    focus $oldfocus
    return $button3
}

proc export {} {

# export to DX

    global fname size xox xoy xoz xdx xdy xdz

    if {[exportd] == 0} {
        BMexport $fname $size $xox $xoy $xoz $xdx $xdy $xdz
    }
}

proc cut {} {

# delete selected node(s)

    global currnode nodex nodey nodez nodes noden button
    global clipnodex clipnodey clipnodez clipnodes
    
    if {$currnode != -1} {
        if {$currnode == -2} {           ;# delete all!
            dialog .cutd {Delete All?} {Are you sure you want to delete\
               everything?} questhead 1 {Make it so} {No}
            if {$button == 0} {
                .fadarea delete node     ;# clear the canvas
                .fbdarea delete node
                .fcdarea delete node
                set clipnodex $nodex     ;# preserve them in clipboard
                set clipnodey $nodey
                set clipnodez $nodez
                set clipnodes $nodes
                set nodex {}             ;# clear the lists
                set nodey {}
                set nodez {}
                set nodes {}
                set noden {}
                BMclear
                set currnode -1
                refresh
            }
        } else {                         ;# delete 1 node
            .fadarea delete $currnode    ;# remove it from the canvas
            .fbdarea delete $currnode
            .fcdarea delete $currnode
            set i [lsearch $noden $currnode] ;# find the selected node
            if {$i == -1} {
                panic [format "cut can't find current node %d" $currnode]
            }
            set clipnodex [list [lindex $nodex $i]] ;# preserve in clipboard
            set clipnodey [list [lindex $nodey $i]]
            set clipnodez [list [lindex $nodez $i]]
            set clipnodes [list [lindex $nodes $i]]
            BMdelete [lindex $noden $i]
            set nodex [lreplace $nodex $i $i] ;# then unlink it from the lists
            set nodey [lreplace $nodey $i $i]
            set nodez [lreplace $nodez $i $i]
            set nodes [lreplace $nodes $i $i]
            set noden [lreplace $noden $i $i]
            set currnode -1
        }
    }
}

proc copy {} {

# copy selected node(s) into the clipboard

    global currnode nodex nodey nodez nodes noden
    global clipnodex clipnodey clipnodez clipnodes
    
    if {$currnode != -1} {
        if {$currnode == -2} {           ;# copy all!
            set clipnodex $nodex         ;# preserve them in clipboard
            set clipnodey $nodey
            set clipnodez $nodez
            set clipnodes $nodes
        } else {                         ;# delete 1 node
            set i [lsearch $noden $currnode] ;# find the selected node
            if {$i == -1} {
                panic [format "copy can't find current node %d" $currnode]
            }
            set clipnodex [list [lindex $nodex $i]] ;# preserve in clipboard
            set clipnodey [list [lindex $nodey $i]]
            set clipnodez [list [lindex $nodez $i]]
            set clipnodes [list [lindex $nodes $i]]
        }
    }
}

proc paste {} {

# paste clipboard to drawing board

    global clipnodex clipnodey clipnodez clipnodes
    global nodex nodey nodez nodes noden

    for {set i 0} {$i < [llength $clipnodex]} {incr i} {
        set x [lindex $clipnodex $i]
        set y [lindex $clipnodey $i]
        set z [lindex $clipnodez $i]
        set strength [lindex $clipnodes $i]
        set new [drawnewnode $x $y $z $strength]
        lappend nodex $x
        lappend nodey $y
        lappend nodez $z
        lappend nodes $strength
        lappend noden $new
        BMadd $x $y $z $strength $new
    }
}

proc selectall {} {

# mark all the nodes as selected

    global currnode nodex

    if {[llength $nodex] != 0} {    
        set currnode -2                  ;# that tells refresh to select all
        refresh
    }
}

proc chgstrength {} {

# edits the strength of the node

    global noden nodes currnode strength

    if {$currnode == -2} {
        dialog .cstrd {Error!} {Sorry, you cannot change the\
            strength of all the nodes at once.} error 0 {Okay}
    } elseif {$currnode != -1} {
        set i [lsearch $noden $currnode] ;# find index of current node
        set strength [lindex $nodes $i]  ;# get its strength to use as default
        getstrength .chgsd "Edit"
        set nodes [lreplace $nodes $i $i $strength]
        BMreplace_s [lindex $noden $i] $strength
        refresh
    }
}

proc chggridsize {} {

# changes the size of the grid

    getgridsize .chggd
    refresh
}    

proc help {} {

# provides an on-line help screen for the user

    global cmd_dir

    textwin .helpd "$cmd_dir/../docs/blobby.hlp" "Help"
}

proc freeops {} {

# handles menu options involving the free window

    global freewindow grid
    
    BMrefresh $freewindow $grid
    refresh
}

proc vanity {} {

# vanity page

    global cmd_dir bm_version button4

    toplevel .v
    
    wm title .v "About Blobby Modeler"
    wm title .v "About..."
    
    canvas .v.c -width 300 -height 200 -relief raised
    pack .v.c
    .v.c create bitmap 10 10 -bitmap "@$cmd_dir/../bitmaps/hole.xbm" \
        -foreground black -background LightSteelBlue -anchor nw
    .v.c create text 210 10 -text "Blobby" -anchor n\
        -font -adobe-times-bold-r-*-*-34-*-*-*-*-*-*-*
    .v.c create text 210 45 -text "Modeler" -anchor n\
        -font -adobe-times-bold-r-*-*-34-*-*-*-*-*-*-*
    .v.c create text 210 83 -text "Version $bm_version" -anchor n \
        -font -adobe-times-bold-r-*-*-18-*-*-*-*-*-*-*
    .v.c create text 150 115 -text "(C) 1995 Szu-Wen (Steven) Huang" \
        -anchor n -font -adobe-times-bold-r-*-*-14-*-*-*-*-*-*-*
    .v.c create text 150 130 -text "In fulfillment of requirements" \
        -anchor n -font -adobe-times-bold-r-*-*-14-*-*-*-*-*-*-*
    .v.c create text 150 145 -text "leading to an MEng Project" \
        -anchor n -font -adobe-times-bold-r-*-*-14-*-*-*-*-*-*-*
    .v.c create text 150 190 -text "Cornell University" \
        -anchor s -font -adobe-times-bold-r-*-*-14-*-*-*-*-*-*-*
    bind .v.c <Button-1> {set button4 1}
    set oldfocus [focus]
    tkwait visibility .v
    grab set .v
    focus .v
    tkwait variable button4
    destroy .v
    focus $oldfocus
}

# button callback functions

proc aup {} {

# up button for xy window

    global appu awy

    if {[expr $awy+100/$appu+0.1] <= 1.05} {
        set awy [expr $awy+0.1]
        .fadarea move node 0 [expr $appu*0.1]
        .fadarea move axes 0 [expr $appu*0.1]
    }
}

proc adn {} {

# down button for xy window

    global appu awy

    if {[expr $awy-100/$appu-0.1] >= -1.05} {
        set awy [expr $awy-0.1]
        .fadarea move node 0 [expr -$appu*0.1]
        .fadarea move axes 0 [expr -$appu*0.1]
    }
}

proc alf {} {

# left button for xy window

    global appu awx
    
    if {[expr $awx-160/$appu-0.1] >= -1.05} {
        set awx [expr $awx-0.1]
        .fadarea move node [expr $appu*0.1] 0
        .fadarea move axes [expr $appu*0.1] 0
    }
}

proc art {} {

# right button for xy window

    global appu awx
    
    if {[expr $awx+160/$appu+0.1] <= 1.05} {
        set awx [expr $awx+0.1]
        .fadarea move node [expr -$appu*0.1] 0
        .fadarea move axes [expr -$appu*0.1] 0
    }
}

proc azin {} {

# zoom in button for xy window
    
    global appu
    
    if {$appu < 1280} {                    ;# 1280 is 4x magnification
        set appu [expr $appu*2]            ;# double the magnification
        refresh
    }
}

proc azout {} {

# zoom out button for xy window

    global appu awx awy
    
    if {$appu > 160} {                     ;# 160 will show all -1..1
        set appu [expr $appu/2]            ;# halve the magnification
        if {[expr $awx+160/$appu] > 1.0} { ;# check if out of bounds
            set awx [expr 1-160/$appu]
        }
        if {[expr $awx-160/$appu] < -1.0} {
            set awx [expr -1+160/$appu]
        }
        if {[expr $awy+100/$appu] > 1.0} {
            set awy [expr 1-100/$appu]
        }
        if {[expr $awy-100/$appu] < -1.0} {
            set awy [expr -1+100/$appu]
        }
        refresh
    }
}

proc bup {} {

# up button for yz window

    global bppu bwy

    if {[expr $bwy+100/$bppu+0.1] <= 1.05} {
        set bwy [expr $bwy+0.1]
        .fbdarea move node 0 [expr $bppu*0.1]
        .fbdarea move axes 0 [expr $bppu*0.1]
    }
}

proc bdn {} {

# down button for yz window

    global bppu bwy

    if {[expr $bwy-100/$bppu-0.1] >= -1.05} {
        set bwy [expr $bwy-0.1]
        .fbdarea move node 0 [expr -$bppu*0.1]
        .fbdarea move axes 0 [expr -$bppu*0.1]
    }
}

proc blf {} {

# left button for yz window

    global bppu bwx
    
    if {[expr $bwx-160/$bppu-0.1] >= -1.05} {
        set bwx [expr $bwx-0.1]
        .fbdarea move node [expr $bppu*0.1] 0
        .fbdarea move axes [expr $bppu*0.1] 0
    }
}

proc brt {} {

# right button for yz window

    global bppu bwx
    
    if {[expr $bwx+160/$bppu+0.1] <= 1.05} {
        set bwx [expr $bwx+0.1]
        .fbdarea move node [expr -$bppu*0.1] 0
        .fbdarea move axes [expr -$bppu*0.1] 0
    }
}

proc bzin {} {

# zoom in button for yz window
    
    global bppu
    
    if {$bppu < 1280} {                    ;# 1280 is 4x magnification
        set bppu [expr $bppu*2]            ;# double the magnification
        refresh
    }
}

proc bzout {} {

# zoom out button for yz window

    global bppu bwx bwy
    
    if {$bppu > 160} {                     ;# 160 will show all -1..1
        set bppu [expr $bppu/2]            ;# halve the magnification
        if {[expr $bwx+160/$bppu] > 1.0} { ;# check if out of bounds
            set bwx [expr 1-160/$bppu]
        }
        if {[expr $bwx-160/$bppu] < -1.0} {
            set bwx [expr -1+160/$bppu]
        }
        if {[expr $bwy+100/$bppu] > 1.0} {
            set bwy [expr 1-100/$bppu]
        }
        if {[expr $bwy-100/$bppu] < -1.0} {
            set bwy [expr -1+100/$bppu]
        }
        refresh
    }
}

proc cup {} {

# up button for xz window

    global cppu cwy

    if {[expr $cwy-100/$cppu-0.1] >= -1.05} {
        set cwy [expr $cwy-0.1]
        .fcdarea move node 0 [expr $cppu*0.1]
        .fcdarea move axes 0 [expr $cppu*0.1]
    }
}

proc cdn {} {

# down button for xz window

    global cppu cwy

    if {[expr $cwy+100/$cppu+0.1] <= 1.05} {
        set cwy [expr $cwy+0.1]
        .fcdarea move node 0 [expr -$cppu*0.1]
        .fcdarea move axes 0 [expr -$cppu*0.1]
    }
}

proc clf {} {

# left button for xz window

    global cppu cwx
    
    if {[expr $cwx-160/$cppu-0.1] >= -1.05} {
        set cwx [expr $cwx-0.1]
        .fcdarea move node [expr $cppu*0.1] 0
        .fcdarea move axes [expr $cppu*0.1] 0
    }
}

proc crt {} {

# right button for xz window

    global cppu cwx
    
    if {[expr $cwx+160/$cppu+0.1] <= 1.05} {
        set cwx [expr $cwx+0.1]
        .fcdarea move node [expr -$cppu*0.1] 0
        .fcdarea move axes [expr -$cppu*0.1] 0
    }
}

proc czin {} {

# zoom in button for xz window
    
    global cppu
    
    if {$cppu < 1280} {                    ;# 1280 is 4x magnification
        set cppu [expr $cppu*2]            ;# double the magnification
        refresh
    }
}

proc czout {} {

# zoom out button for xz window

    global cppu cwx cwy
    
    if {$cppu > 160} {                     ;# 160 will show all -1..1
        set cppu [expr $cppu/2]            ;# halve the magnification
        if {[expr $cwx+160/$cppu] > 1.0} { ;# check if out of bounds
            set cwx [expr 1-160/$cppu]
        }
        if {[expr $cwx-160/$cppu] < -1.0} {
            set cwx [expr -1+160/$cppu]
        }
        if {[expr $cwy+100/$cppu] > 1.0} {
            set cwy [expr 1-100/$cppu]
        }
        if {[expr $cwy-100/$cppu] < -1.0} {
            set cwy [expr -1+100/$cppu]
        }
        refresh
    }
}

proc draw {} {

# draw mode (pencil) button for all windows

    global currnode

    .fadarea config -cursor tcross       ;# edit areas shd have x-hair
    .fbdarea config -cursor tcross       ;# cursor
    .fcdarea config -cursor tcross
    .fadarea bind node <Button-1> {}     ;# unbind dragging
    .fadarea bind node <B1-Motion> {}
    .fbdarea bind node <Button-1> {}
    .fbdarea bind node <B1-Motion> {}
    .fcdarea bind node <Button-1> {}
    .fcdarea bind node <B1-Motion> {}
    bind .fadarea <Button-1> {newanode %x %y} ;# bind B1 for new node
    bind .fbdarea <Button-1> {newbnode %x %y}
    bind .fcdarea <Button-1> {newcnode %x %y}
    if {$currnode != -1} {           ;# clear previous selection
        .fadarea itemconfigure $currnode -outline black
        .fbdarea itemconfigure $currnode -outline black
        .fcdarea itemconfigure $currnode -outline black
        if {$currnode == -2} {
            .fadarea itemconfigure node -outline black
            .fbdarea itemconfigure node -outline black
            .fcdarea itemconfigure node -outline black
        }
    }
    set currnode -1
}

proc get {} {

# get mode (arrow) button for all windows

    .fadarea config -cursor top_left_arrow ;# edit area shd have arrow
    .fbdarea config -cursor top_left_arrow ;# cursor now
    .fcdarea config -cursor top_left_arrow
    .fadarea bind node <Button-1> {      ;# bind for dragging
        set curx %x
        set cury %y
        if {$currnode != -1} {           ;# clear previous selection
            .fadarea itemconfigure $currnode -outline black
            .fbdarea itemconfigure $currnode -outline black
            .fcdarea itemconfigure $currnode -outline black
            if {$currnode == -2} {
                .fadarea itemconfigure node -outline black
                .fbdarea itemconfigure node -outline black
                .fcdarea itemconfigure node -outline black
            }
        }
        set currnode [.fadarea find withtag current]
        .fadarea itemconfigure $currnode -outline blue
        .fbdarea itemconfigure $currnode -outline blue
        .fcdarea itemconfigure $currnode -outline blue
    }
    .fadarea bind node <B1-Motion> {
        draganode [.fadarea find withtag current] [expr %x-$curx] \
            [expr %y-$cury]
        set curx %x
        set cury %y
    }
    .fbdarea bind node <Button-1> {
        set curx %x
        set cury %y
        if {$currnode != -1} {
            .fadarea itemconfigure $currnode -outline black
            .fbdarea itemconfigure $currnode -outline black
            .fcdarea itemconfigure $currnode -outline black
            if {$currnode == -2} {
                .fadarea itemconfigure node -outline black
                .fbdarea itemconfigure node -outline black
                .fcdarea itemconfigure node -outline black
            }
        }
        set currnode [.fbdarea find withtag current]
        .fadarea itemconfigure $currnode -outline blue
        .fbdarea itemconfigure $currnode -outline blue
        .fcdarea itemconfigure $currnode -outline blue
    }
    .fbdarea bind node <B1-Motion> {
        dragbnode [.fbdarea find withtag current] [expr %x-$curx] \
            [expr %y-$cury]
        set curx %x
        set cury %y
    }
    .fcdarea bind node <Button-1> {
        set curx %x
        set cury %y
        if {$currnode != -1} {
            .fadarea itemconfigure $currnode -outline black
            .fbdarea itemconfigure $currnode -outline black
            .fcdarea itemconfigure $currnode -outline black
            if {$currnode == -2} {
                .fadarea itemconfigure node -outline black
                .fbdarea itemconfigure node -outline black
                .fcdarea itemconfigure node -outline black
            }
        }
        set currnode [.fcdarea find withtag current]
        .fadarea itemconfigure $currnode -outline blue
        .fbdarea itemconfigure $currnode -outline blue
        .fcdarea itemconfigure $currnode -outline blue
    }
    .fcdarea bind node <B1-Motion> {
        dragcnode [.fcdarea find withtag current] [expr %x-$curx] \
            [expr %y-$cury]
        set curx %x
        set cury %y
    }
    bind .fadarea <Button-1> {}          ;# unbind B1 -> new node
    bind .fbdarea <Button-1> {}
    bind .fcdarea <Button-1> {}    
}

# canvas editing functions

proc drawnewnode {xx yy zz strength} {

# draws a new node in all 3/4 windows
# entry: xx, yy, zz      world coordinate for center of atom
#        strength        world coordinate radius of atom
# exit:  returns a number to the new node created

    global awx awy appu bwx bwy bppu cwx cwy cppu freewindow grid

    set s [expr $strength*$appu]         ;# xy
    set x [expr 160+($xx-$awx)*$appu]
    set y [expr 100-($yy-$awy)*$appu]
    set new [.fadarea create oval [expr $x-$s] [expr $y-$s] \
        [expr $x+$s] [expr $y+$s] -outline black -tags node]
    set s [expr $strength*$bppu]         ;# yz
    set z [expr 160+($zz-$bwx)*$bppu]
    set y [expr 100-($yy-$bwy)*$bppu]
    .fbdarea create oval [expr $z-$s] [expr $y-$s] \
        [expr $z+$s] [expr $y+$s] -outline black -tags node
    set s [expr $strength*$cppu]         ;# xz
    set x [expr 160+($xx-$cwx)*$cppu]
    set z [expr 100+($zz-$cwy)*$cppu]
    .fcdarea create oval [expr $x-$s] [expr $z-$s] \
        [expr $x+$s] [expr $z+$s] -outline black -tags node
    if {$freewindow == 1} {
        BMrefresh $freewindow $grid
    }
    return $new
}

proc freeoval {x1 y1 x2 y2} {

# draws ovals in the free window for the C subprogram so we can change
# parameters here instead and not recompile instead of there...
# entry: x1, y1, x2, y2  bounding box of oval
# exit:  returns the new node created

    set fn [.fddarea create oval $x1 $y1 $x2 $y2 -outline black \
        -fill gray60 -tags node]
    set dx [expr $x2-$x1]
    set dy [expr $y2-$y1]
    .fddarea create oval [expr $x1+$dx*0.11] [expr $y1+$dy*0.11] \
        [expr $x1+$dx*0.6] [expr $y1+$dy*0.6] -fill gray70 \
        -outline gray70 -tags node
    .fddarea create oval [expr $x1+$dx*0.2] [expr $y1+$dy*0.2] \
        [expr $x1+$dx*0.35] [expr $y1+$dy*0.35] -fill gray80 \
        -outline gray80 -tags node
    return $fn
}

proc drawaxes {} {

# draws the grid axes for all 3 windows

    global gridsize awx awy appu bwx bwy bppu cwx cwy cppu

    for {set i $gridsize} {$i <= 1.0} {set i [expr $i+$gridsize]} {
        set t1 [expr 100-(-1-$awy)*$appu]
        set t2 [expr 100-(1-$awy)*$appu]
        set x [expr 160+($i-$awx)*$appu] ;# xy
        .fadarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set x [expr 160+(-$i-$awx)*$appu]
        .fadarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set t1 [expr 160+(-1-$awx)*$appu]
        set t2 [expr 160+(1-$awx)*$appu]
        set y [expr 100-($i-$awy)*$appu]
        .fadarea create line $t1 $y $t2 $y -fill Gray -tags axes
        set y [expr 100-(-$i-$awy)*$appu]
        .fadarea create line $t1 $y $t2 $y -fill Gray -tags axes
        
        set t1 [expr 100-(-1-$bwy)*$bppu]
        set t2 [expr 100-(1-$bwy)*$bppu]
        set x [expr 160+($i-$bwx)*$bppu] ;# yz
        .fbdarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set x [expr 160+(-$i-$bwx)*$bppu]
        .fbdarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set t1 [expr 160+(-1-$bwx)*$bppu]
        set t2 [expr 160+(1-$bwx)*$bppu]
        set y [expr 100-($i-$bwy)*$bppu]
        .fbdarea create line $t1 $y $t2 $y -fill Gray -tags axes
        set y [expr 100-(-$i-$bwy)*$bppu]
        .fbdarea create line $t1 $y $t2 $y -fill Gray -tags axes
        
        set t1 [expr 100+(-1-$cwy)*$cppu]
        set t2 [expr 100+(1-$cwy)*$cppu]
        set x [expr 160+($i-$cwx)*$cppu] ;# xz
        .fcdarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set x [expr 160+(-$i-$cwx)*$cppu]
        .fcdarea create line $x $t1 $x $t2 -fill Gray -tags axes
        set t1 [expr 160+(-1-$cwx)*$cppu]
        set t2 [expr 160+(1-$cwx)*$cppu]
        set y [expr 100+($i-$cwy)*$cppu]
        .fcdarea create line $t1 $y $t2 $y -fill Gray -tags axes
        set y [expr 100+(-$i-$cwy)*$cppu]
        .fcdarea create line $t1 $y $t2 $y -fill Gray -tags axes
    }
    
    #coordinate axes

    
    set x [expr 160-$awx*$appu]          ;# xy
    set t1 [expr 100-(-1-$awy)*$appu]
    set t2 [expr 100-(1-$awy)*$appu]
    .fadarea create line $x $t1 $x $t2 -fill SlateGray -tags axes
    set t1 [expr 160+(-1-$awx)*$appu]
    set t2 [expr 160+(1-$awx)*$appu]
    set y [expr 100+$awy*$appu]
    .fadarea create line $t1 $y $t2 $y -fill SlateGray -tags axes
    
    set t1 [expr 100-(-1-$bwy)*$bppu]
    set t2 [expr 100-(1-$bwy)*$bppu]
    set x [expr 160-$bwx*$bppu]          ;# xz
    .fbdarea create line $x $t1 $x $t2 -fill SlateGray -tags axes
    set t1 [expr 160+(-1-$bwx)*$bppu]
    set t2 [expr 160+(1-$bwx)*$bppu]
    set y [expr 100+$bwy*$bppu]
    .fbdarea create line $t1 $y $t2 $y -fill SlateGray -tags axes
    
    set t1 [expr 100+(-1-$cwy)*$cppu]
    set t2 [expr 100+(1-$cwy)*$cppu]
    set x [expr 160-$cwx*$cppu]          ;# yz
    .fcdarea create line $x $t1 $x $t2 -fill SlateGray -tags axes
    set t1 [expr 160+(-1-$cwx)*$cppu]
    set t2 [expr 160+(1-$cwx)*$cppu]
    set y [expr 100-$cwy*$cppu]
    .fcdarea create line $t1 $y $t2 $y -fill SlateGray -tags axes
}

proc refresh {} {

# refreshes the display (all 3/4 windows)

    global nodex nodey nodez nodes noden grid currnode freewindow

    set currnodeindex -1                 ;# pretend none selected
    if {$currnode >= 0} {                ;# is something selected?
        set currnodeindex [lsearch $noden $currnode] ;# preserve its index
    }
    .fadarea delete node                 ;# remove all the old nodes
    .fbdarea delete node
    .fcdarea delete node
    .fadarea delete axes
    .fbdarea delete axes
    .fcdarea delete axes
    if {$grid == 1} {
        drawaxes
    }
    for {set i 0} {$i < [llength $nodex]} {incr i} {
        set new [drawnewnode [lindex $nodex $i] [lindex $nodey $i] \
            [lindex $nodez $i] [lindex $nodes $i]]
        BMreplace_n [lindex $noden $i] $new ;# tell freewindow about it
        set noden [lreplace $noden $i $i $new] ;# refresh node numbers
    }
    if {$currnodeindex != -1} {          ;# did we save an index?
        set currnode [lindex $noden $currnodeindex]
        .fadarea itemconfigure $currnode -outline blue
        .fbdarea itemconfigure $currnode -outline blue
        .fcdarea itemconfigure $currnode -outline blue
    } else {
        if {$currnode == -2} {           ;# oh, all selected
            .fadarea itemconfigure node -outline blue
            .fbdarea itemconfigure node -outline blue
            .fcdarea itemconfigure node -outline blue
        }
    }
}    

proc newanode {x y} {

# creates a node in the xy window
# entry: x, y            screen coordinates of click

    global strength nodex nodey nodez nodes noden appu awx awy

    getstrength .strengthd "New"
    set xx [expr $awx+($x-160)/$appu]
    set yy [expr $awy-($y-100)/$appu]
    set new [drawnewnode $xx $yy 0.0 $strength]
    lappend nodex $xx
    lappend nodey $yy
    lappend nodez 0.0
    lappend nodes $strength
    lappend noden $new
    BMadd $xx $yy 0.0 $strength $new
}

proc draganode {node dx dy} {

# drags a node in the xy window
# entry: node            node number selected
#        dx, dy          distance dragged

    global nodex nodey noden appu

    .fadarea move $node $dx $dy
    .fbdarea move $node 0 $dy
    .fcdarea move $node $dx 0
    set i [lsearch $noden $node]
    if {$i == -1} {
        panic [format "draganode can't find node #%d" $node]
    }
    BMtranslate_xy [lindex $noden $i] [expr $dx/$appu] [expr $dy/$appu]
    set nodex [lreplace $nodex $i $i [expr [lindex $nodex $i]+$dx/$appu]]
    set nodey [lreplace $nodey $i $i [expr [lindex $nodey $i]-$dy/$appu]]
}

proc newbnode {x y} {

# creates a node in the yz window (see above for parameters)

    global strength nodex nodey nodez nodes noden bppu bwx bwy

    getstrength .strengthd "New"
    set yy [expr $bwy-($y-100)/$bppu]
    set zz [expr $bwx+($x-160)/$bppu]
    set new [drawnewnode 0.0 $yy $zz $strength]
    lappend nodex 0.0
    lappend nodey $yy
    lappend nodez $zz
    lappend nodes $strength
    lappend noden $new
    BMadd 0.0 $yy $zz $strength $new
}

proc dragbnode {node dx dy} {

# drags a node in the yz window (see above)

    global nodey nodez noden bppu

    .fadarea move $node 0 $dy
    .fbdarea move $node $dx $dy
    .fcdarea move $node 0 $dx
    set i [lsearch $noden $node]
    if {$i == -1} {
        panic [format "dragbnode can't find node #%d" $node]
    }    
    BMtranslate_yz [lindex $noden $i] [expr $dy/$bppu] [expr $dx/$bppu]
    set nodez [lreplace $nodez $i $i [expr [lindex $nodez $i]+$dx/$bppu]]
    set nodey [lreplace $nodey $i $i [expr [lindex $nodey $i]-$dy/$bppu]]
}

proc newcnode {x y} {

# creates a node in the xz window (see above)

    global strength nodex nodey nodez nodes noden cppu cwx cwy

    getstrength .strengthd "New"
    set xx [expr $cwx+($x-160)/$cppu]
    set zz [expr $cwy+($y-100)/$cppu]
    set new [drawnewnode $xx 0.0 $zz $strength]
    lappend nodex $xx
    lappend nodey 0.0
    lappend nodez $zz
    lappend nodes $strength
    lappend noden $new
    BMadd $xx 0.0 $zz $strength $new
}

proc dragcnode {node dx dy} {

# drags a node in the xz window (see above)

    global nodex nodez noden cppu

    .fadarea move $node $dx 0
    .fbdarea move $node $dy 0
    .fcdarea move $node $dx $dy
    set i [lsearch $noden $node]
    if {$i == -1} {
        panic [format "dragcnode can't find node #%d" $node]
    }
    BMtranslate_xz [lindex $noden $i] [expr $dx/$cppu] [expr $dy/$cppu]
    set nodex [lreplace $nodex $i $i [expr [lindex $nodex $i]+$dx/$cppu]]
    set nodez [lreplace $nodez $i $i [expr [lindex $nodez $i]+$dy/$cppu]]
}

# convenience procedures

proc panic {msg} {

# prints an error message and halt the program
# entry: msg             message to print

    puts "Blobby Modeler Fatal Error:"
    puts $msg
    exit
}

# startup code

set freewindow 1                         ;# free window defaults to ..
set strength 0.1                         ;# atom strength defaults to ..
set grid 1                               ;# grids default to ..
set gridsize 0.2                         ;# grid size defaults to ..
set filename "untitled.bm"               ;# default filename

set awx 0.0                              ;# window center for xy pane
set awy 0.0
set bwx 0.0                              ;# window center for yz pane
set bwy 0.0
set cwx 0.0                              ;# window center for xz pane
set cwy 0.0
set appu 160.0                           ;# pixels per unit
set bppu 160.0
set cppu 160.0
set nodex {}                             ;# initialize node parallel arrays
set nodey {}
set nodez {}
set nodes {}
set noden {}
set clipnodex {}                         ;# clean clipboard
set clipnodey {}
set clipnodez {}
set clipnodes {}
set currnode -1                          ;# no current node
set fname "untitled.dx"                  ;# default export file name
set size 31                              ;# sample size (31^3)
set xox 0.0                              ;# origin
set xoy 0.0
set xoz 0.0
set xdx [expr 1.0/($size-1)]             ;# delta
set xdy [expr 1.0/($size-1)]
set xdz [expr 1.0/($size-1)]

if {$grid == 1} {
    drawaxes
}

wm title . "Blobby Modeler"              ;# tell window manager who we are
wm iconname . "Blobby Modeler"

bind all <Control-a> { selectall }
bind all <Control-c> { copy }
bind all <Control-e> { export }
bind all <Control-n> { new }
bind all <Control-o> { openfile }
bind all <Control-q> { quit }
bind all <Control-s> { savefile }
bind all <Control-t> { chgstrength }
bind all <Control-v> { paste }
bind all <Control-x> { cut }
